// PCIe_IDIO_24.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include "AIOWDM.h"

int main()
{
	int NumberOfDetectedCards = GetNumCards();
	long CardNum = -1;

	std::cout << NumberOfDetectedCards << " cards detected."<< std::endl;
	if (NumberOfDetectedCards == 0)
	{
		std::cout << "Sample requires one PCIe-IDIO-24 be installed. Check Device Manager for errors."<<std::flush;
		return 1;
	}

	for (int i = 0; i < NumberOfDetectedCards; i++)
	{
		unsigned long DeviceID, NameSize = 0;
		QueryCardInfo(i, &DeviceID, NULL, &NameSize, NULL);
		unsigned char * Name = new unsigned char[NameSize];
		QueryCardInfo(i, NULL, NULL, &NameSize, Name);

		std::cout << Name << " found at CardNum: " << i << std::endl;
		
		if (DeviceID == 0x0FD0)
		{
			CardNum = i;
			break;
		}
	}

	RelOutPortB(CardNum, 0xC, 0b0001); // disable filters, configure TTL0-7 as input, enable TTL buffers
	// RelOutPortB(CardNum, 0xC, 0b0001); // disable filters, configure TTL0-7 as input, enable TTL buffers
	// RelOutPortB(CardNum, 0xC, 0b0011); // disable filters, configure TTL0-7 as output, enable TTL buffers
	// RelOutPortB(CardNum, 0xC, 0b1101); // enable filters, configure TTL0-7 as input, enable TTL buffers


	unsigned long InputData = RelInPortL(CardNum, 4); // read 24 ISO inputs and 8 TTL
	std::cout <<"Value read from inputs: "<< std::hex << InputData << std::endl;
	
	unsigned long OutputData = 0x12345678; 
	RelOutPortL(CardNum, 0, OutputData); // write "345678" to the FET outputs, and "12" to the TTL Inputs (which will ignore writes)

	InputData = RelInPortL(CardNum, 4); // read 24 ISO inputs and 8 TTL
	std::cout << "Value read from inputs: " << std::hex << InputData << std::endl;

	std::cout << "Sample Complete" << std::endl;

	return 0;
}